unit UnIncItenCompra;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, Mask, DBCtrls;

type
  TFrmIncluirItenComp = class(TForm)
    TxtLocProdComp: TDBLookupComboBox;
    Label1: TLabel;
    TxtDescriItem: TDBEdit;
    PnBdcItemComp: TPanel;
    BdcOk: TBitBtn;
    BdcIncluir: TBitBtn;
    BdcCancelar: TBitBtn;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    EdQutCompra: TEdit;
    EdEstoque: TEdit;
    EdVlrUntComp: TEdit;
    TxtCod: TDBEdit;
    TxtGarantia: TDBEdit;
    TxtVlr: TDBEdit;
    procedure TxtLocProdCompClick(Sender: TObject);
    procedure BdcOkClick(Sender: TObject);
    procedure BdcIncluirClick(Sender: TObject);
    procedure BdcCancelarClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure TxtLocProdCompKeyPress(Sender: TObject; var Key: Char);
    procedure EdQutCompraKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmIncluirItenComp: TFrmIncluirItenComp;
  
implementation

uses  UntOS;

{$R *.dfm}

procedure TFrmIncluirItenComp.TxtLocProdCompClick(Sender: TObject);
begin
EdEstoque.Text:=TxtGarantia.Text;
EdVlrUntComp.Text:=TxtVlr.Text;
FrmOS.TbItemOS.FieldValues['Val_Unit']:=EdVlrUntComp.Text;
TxtDescriItem.Text:=TxtLocProdComp.Text;
FrmOS.TbItemOS.FieldValues['Nome']:=TxtDescriItem.Text;
FrmOS.TbItemOS.FieldValues['Cod_Produto']:=TxtCod.Text;
FrmOS.TbItemOS.FieldValues['Garantia']:=TxtGarantia.Text;
EdQutCompra.SetFocus;
end;

procedure TFrmIncluirItenComp.BdcOkClick(Sender: TObject);
begin
If EdQutCompra.Text<='0' then
  Begin
    Application.MessageBox('A quantidade de servio deve ser informada.','SC Software',MB_ICONINFORMATION);
    EdQutCompra.SetFocus;
    Abort;
end
      Else
        Begin
          FrmOS.TbItemOS.Edit;
          FrmOS.TbItemOS.FieldValues['Qtd']:=EdQutCompra.Text;

        FrmOS.TbItemOS.FieldValues['Sub_Total']:=FrmOS.TbItemOS.FieldValues['Val_Unit']*FrmOS.TbItemOS.FieldValues['Qtd'];
        FrmOS.TbOS.Edit;
FrmOS.TbOSValor_Nota_1.AsCurrency:=FrmOS.TbOSValor_Nota_1.AsCurrency+FrmOS.TbItemOSSub_Total.AsCurrency;
EdQutCompra.Clear;
BdcOk.Enabled:=False;
BdcIncluir.Enabled:=True;
BdcCancelar.Enabled:=False;
TxtLocProdComp.Enabled:=False;
EdQutCompra.Enabled:=False;
end

end;

procedure TFrmIncluirItenComp.BdcIncluirClick(Sender: TObject);
begin
FrmOS.TbItemOS.Insert;
TxtLocProdComp.Enabled:=True;
EdQutCompra.Enabled:=True;
TxtLocProdComp.DropDown;
TxtLocProdComp.SetFocus;
BdcOk.Enabled:=True;
BdcIncluir.Enabled:=False;
BdcCancelar.Enabled:=True;
end;

procedure TFrmIncluirItenComp.BdcCancelarClick(Sender: TObject);
begin
BdcOk.Enabled:=False;
BdcIncluir.Enabled:=True;
BdcIncluir.SetFocus;
BdcCancelar.Enabled:=False;
FrmOS.TbItemOS.Cancel;
EdQutCompra.Clear;
FrmOS.TbProOS.Append;
EdEstoque.Clear;
EdVlrUntComp.Clear;
TxtDescriItem.Clear;
TxtLocProdComp.Enabled:=False;
EdQutCompra.Enabled:=False;
end;

procedure TFrmIncluirItenComp.FormActivate(Sender: TObject);
begin
{TxtLocProdComp.Enabled:=True;
EdQutCompra.Enabled:=True;
TxtLocProdComp.DropDown;
TxtLocProdComp.SetFocus;  }
BdcOk.Enabled:=False;
BdcIncluir.Enabled:=True;
BdcCancelar.Enabled:=False;
end;

procedure TFrmIncluirItenComp.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
Action:=caFree;
FrmIncluirItenComp:=Nil;
end;

procedure TFrmIncluirItenComp.FormKeyPress(Sender: TObject; var Key: Char);
begin
If Key=#27 Then
  Begin
    FrmIncluirItenComp.Close;
end;
end;

procedure TFrmIncluirItenComp.TxtLocProdCompKeyPress(Sender: TObject;
  var Key: Char);
begin
If Key=#13 then
  Begin
    Key:=#0;
    SelectNext(ActiveControl,True,True);
end
end;

procedure TFrmIncluirItenComp.EdQutCompraKeyPress(Sender: TObject;
  var Key: Char);
begin
If Key=#13 then
  Begin
    Key:=#0;
    SelectNext(ActiveControl,True,True);
end
end;

end.
