unit UntCadCliente;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, DBCtrls, ExtCtrls, ComCtrls, DB, Mask, Shellapi,
  ADODB;

type
  TFrmCadCliente = class(TForm)
    PageControl1: TPageControl;
    DadosPessoais: TTabSheet;
    DadosEndereco: TTabSheet;
    PNLocUsu: TPanel;
    Label8: TLabel;
    TxtLocCliente: TDBLookupComboBox;
    PnBDCUsu: TPanel;
    BdcNovo: TBitBtn;
    BdcSalvar: TBitBtn;
    BdcAlterar: TBitBtn;
    BdcExcluir: TBitBtn;
    BdcCancelar: TBitBtn;
    Label1: TLabel;
    TxtCodCadCliente: TDBEdit;
    DsCadCliente: TDataSource;
    Label2: TLabel;
    TxtDCadCliente: TDBEdit;
    Label3: TLabel;
    Label4: TLabel;
    TxtNomeFanCadCliente: TDBEdit;
    Label5: TLabel;
    TxtDNascCadCliente: TDBEdit;
    Label6: TLabel;
    TxtCPFCadCliente: TDBEdit;
    Label7: TLabel;
    TxtIECadCliente: TDBEdit;
    Label9: TLabel;
    TxtCNPJCadCliente: TDBEdit;
    LblRS: TLabel;
    TxtRSCadCliente: TDBEdit;
    Label11: TLabel;
    TxtRGCadCliente: TDBEdit;
    Label12: TLabel;
    Label15: TLabel;
    TxtFoneCadCliente: TDBEdit;
    Label16: TLabel;
    TxtFaxCadCliente: TDBEdit;
    Label17: TLabel;
    TxtEMailCadCliente: TDBEdit;
    Label18: TLabel;
    TxtSiteCadCliente: TDBEdit;
    Label19: TLabel;
    TxtEndCadCliente: TDBEdit;
    Label20: TLabel;
    TxtCidadeCadCliente: TDBEdit;
    Label21: TLabel;
    TxtCEPCadCliente: TDBEdit;
    Label22: TLabel;
    TxtLocTipoCadCliente: TDBComboBox;
    TxtOBSCadCliente: TDBMemo;
    TxtLocUFCadCliente: TDBComboBox;
    BdcEMail: TButton;
    BdcSite: TButton;
    TbCadCliente: TADOTable;
    TbCadClienteCodigo_Cliente: TAutoIncField;
    TbCadClienteData_Cad: TDateTimeField;
    TbCadClientePF_PJ: TWideStringField;
    TbCadClienteNome: TWideStringField;
    TbCadClienteData_Nascimento: TDateTimeField;
    TbCadClienteCPF: TWideStringField;
    TbCadClienteIE: TWideStringField;
    TbCadClienteCGC: TWideStringField;
    TbCadClienteRazao_Social: TWideStringField;
    TbCadClienteRG: TWideStringField;
    TbCadClienteFone: TWideStringField;
    TbCadClienteFax: TWideStringField;
    TbCadClienteE_Mail: TWideStringField;
    TbCadClienteSite: TWideStringField;
    TbCadClienteEndereco: TWideStringField;
    TbCadClienteCidade: TWideStringField;
    TbCadClienteCEP: TWideStringField;
    TbCadClienteUF: TWideStringField;
    TbCadClienteObs: TMemoField;
    procedure BdcNovoClick(Sender: TObject);
    procedure BdcSalvarClick(Sender: TObject);
    procedure BdcAlterarClick(Sender: TObject);
    procedure BdcExcluirClick(Sender: TObject);
    procedure BdcCancelarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TxtLocTipoCadClienteClick(Sender: TObject);
    procedure TxtLocTipoCadClienteExit(Sender: TObject);
    procedure BdcEMailClick(Sender: TObject);
    procedure TxtLocClienteClick(Sender: TObject);
    procedure TxtLocClienteExit(Sender: TObject);
    procedure TxtCodCadClienteKeyPress(Sender: TObject; var Key: Char);
    procedure TxtLocTipoCadClienteKeyPress(Sender: TObject; var Key: Char);
    procedure TxtRSCadClienteKeyPress(Sender: TObject; var Key: Char);
    procedure TxtNomeFanCadClienteKeyPress(Sender: TObject; var Key: Char);
    procedure TxtCNPJCadClienteKeyPress(Sender: TObject; var Key: Char);
    procedure TxtIECadClienteKeyPress(Sender: TObject; var Key: Char);
    procedure TxtDCadClienteKeyPress(Sender: TObject; var Key: Char);
    procedure TxtDNascCadClienteKeyPress(Sender: TObject; var Key: Char);
    procedure TxtCPFCadClienteKeyPress(Sender: TObject; var Key: Char);
    procedure TxtRGCadClienteKeyPress(Sender: TObject; var Key: Char);
    procedure TxtOBSCadClienteKeyPress(Sender: TObject; var Key: Char);
    procedure TxtEndCadClienteKeyPress(Sender: TObject; var Key: Char);
    procedure TxtCidadeCadClienteKeyPress(Sender: TObject; var Key: Char);
    procedure TxtCEPCadClienteKeyPress(Sender: TObject; var Key: Char);
    procedure TxtFoneCadClienteKeyPress(Sender: TObject; var Key: Char);
    procedure TxtEMailCadClienteKeyPress(Sender: TObject; var Key: Char);
    procedure TxtLocUFCadClienteKeyPress(Sender: TObject; var Key: Char);
    procedure TxtFaxCadClienteKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure BdcGerarCodSenKeyPress(Sender: TObject; var Key: Char);
    procedure BdcSiteClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmCadCliente: TFrmCadCliente;

implementation

uses ComObj, UntSCV;

{$R *.dfm}

procedure TFrmCadCliente.BdcNovoClick(Sender: TObject);
begin
PageControl1.TabIndex:=0;
TbCadCliente.Active:=True;
TbCadCliente.Append;
TbCadCliente.FieldValues['Data_Cad']:=DateToStr(Date);
TbCadClienteData_Nascimento.EditMask:='!##\/##\/##;1;_';
TxtLocTipoCadCliente.SetFocus;
TxtLocTipoCadCliente.DroppedDown;
BdcNovo.Enabled:=False;
BdcSalvar.Enabled:=True;
BdcAlterar.Enabled:=False;
BdcExcluir.Enabled:=False;
BdcCancelar.Enabled:=True;
TxtLocCliente.Enabled:=False;
end;

procedure TFrmCadCliente.BdcSalvarClick(Sender: TObject);
begin
If (TxtDCadCliente.Text='') or (TxtRSCadCliente.Text='') Then
  Begin
    Application.MessageBox('Dados Insuficiente para realizar o cadastro!','SC Software',MB_ICONINFORMATION);
end
      Else
        Begin
          TbCadCliente.Post;
          TbCadCliente.Refresh;
          TbCadCliente.Active:=False;
          BdcNovo.Enabled:=True;
          BdcSalvar.Enabled:=False;
          BdcAlterar.Enabled:=True;
          BdcExcluir.Enabled:=False;
          BdcCancelar.Enabled:=False;
          TxtLocCliente.Enabled:=False;
      end
end;

procedure TFrmCadCliente.BdcAlterarClick(Sender: TObject);
begin
TbCadCliente.Active:=True;
TbCadCliente.Append;
TbCadCliente.Edit;
BdcNovo.Enabled:=False;
BdcSalvar.Enabled:=True;
BdcAlterar.Enabled:=False;
BdcExcluir.Enabled:=True;
BdcCancelar.Enabled:=True;
TxtLocCliente.Enabled:=True;
TxtLocCliente.DropDown;
TxtLocCliente.SetFocus
end;

procedure TFrmCadCliente.BdcExcluirClick(Sender: TObject);
begin
If TxtCodCadCliente.Text='' then
  Begin
    Application.MessageBox('No existe cadastro selecionado para ser excluido...'#13'Volte e selecione o cadastro que deseja exluir...','SC Software',MB_ICONINFORMATION);
    TxtLocCliente.DropDown;
    TxtLocCliente.SetFocus;
end
      Else
        If Application.MessageBox('A T E N   O...'#13'Deseja realmente excluir este registro?','SC Software',MB_YESNO+MB_ICONQUESTION)=mrYes then
          Begin
            TbCadCliente.Delete;
            Application.MessageBox('Registro excluido com sucesso...','SC Software',MB_ICONINFORMATION);
            TbCadCliente.Active:=False;
            BdcNovo.Enabled:=True;
            BdcSalvar.Enabled:=False;
            BdcAlterar.Enabled:=True;
            BdcExcluir.Enabled:=False;
            BdcCancelar.Enabled:=False;
            TxtLocCliente.Enabled:=False;
        end
end;

procedure TFrmCadCliente.BdcCancelarClick(Sender: TObject);
begin
If Application.MessageBox('A T E N   O ! ! !'#13'Realmente deseja cancelar esta ao???','SC Software',MB_ICONQUESTION+MB_YESNO)=mrYes Then
  Begin
    TbCadCliente.Cancel;
    TbCadCliente.Active:=False;
    BdcNovo.Enabled:=True;
    BdcSalvar.Enabled:=False;
    BdcAlterar.Enabled:=True;
    BdcExcluir.Enabled:=False;
    BdcCancelar.Enabled:=False;
    TxtLocCliente.Enabled:=False
end
      Else
        Abort;
end;

procedure TFrmCadCliente.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
TbCadCliente.Active:=False;
Action:=caFree;
FrmCadCliente:=Nil;
end;

procedure TFrmCadCliente.TxtLocTipoCadClienteClick(Sender: TObject);
begin
If TxtLocTipoCadCliente.Text='PESSOA JURDICA' then
  Begin
    TxtCPFCadCliente.Visible:=False;
    TxtRGCadCliente.Visible:=False;
    TxtNomeFanCadCliente.Visible:=True;
    TxtCNPJCadCliente.Visible:=True;
    TxtIECadCliente.Visible:=True;
    Label9.Visible:=True;
    Label7.Visible:=True;
    Label6.Visible:=False;
    Label11.Visible:=False;
    Label4.Visible:=True;
    Label5.Enabled:=False;
    TxtDNascCadCliente.Enabled:=False;
    LblRS.Caption:='Razo Social';
    TbCadClienteCGC.EditMask:='!##\.###\.###\/####\-##;1;_';
end
    else
      If TxtLocTipoCadCliente.Text='PESSOA FSICA' then
        Begin
          TxtNomeFanCadCliente.Visible:=False;
          TxtCNPJCadCliente.Visible:=False;
          TxtIECadCliente.Visible:=False;
          TxtCPFCadCliente.Visible:=True;
          TxtRGCadCliente.Visible:=True;
          Label9.Visible:=False;
          Label7.Visible:=False;
          Label6.Visible:=True;
          Label11.Visible:=True;
          Label4.Visible:=False;
          Label5.Enabled:=True;
          TxtDNascCadCliente.Enabled:=True;
          LblRS.Caption:='Nome';
          TbCadClienteRG.EditMask:='!###\.###\.###\-##;1;_';
          TbCadClienteCPF.EditMask:='!###\.###\.###\-##;1;_'
      end
end;

procedure TFrmCadCliente.TxtLocTipoCadClienteExit(Sender: TObject);
begin
If TxtLocTipoCadCliente.Text='PESSOA JURDICA' then
  Begin
    TxtCPFCadCliente.Visible:=False;
    TxtRGCadCliente.Visible:=False;
    TxtNomeFanCadCliente.Visible:=True;
    TxtCNPJCadCliente.Visible:=True;
    TxtIECadCliente.Visible:=True;
    Label9.Visible:=True;
    Label7.Visible:=True;
    Label6.Visible:=False;
    Label11.Visible:=False;
    Label4.Visible:=True;
    Label5.Enabled:=False;
    TxtDNascCadCliente.Enabled:=False;
    LblRS.Caption:='Razo Social';
    TbCadClienteCGC.EditMask:='!##\.###\.###\/####\-##;1;_';
end
    else
      If TxtLocTipoCadCliente.Text='PESSOA FSICA' then
        Begin
          TxtNomeFanCadCliente.Visible:=False;
          TxtCNPJCadCliente.Visible:=False;
          TxtIECadCliente.Visible:=False;
          TxtCPFCadCliente.Visible:=True;
          TxtRGCadCliente.Visible:=True;
          Label9.Visible:=False;
          Label7.Visible:=False;
          Label6.Visible:=True;
          Label11.Visible:=True;
          Label4.Visible:=False;
          Label5.Enabled:=True;
          TxtDNascCadCliente.Enabled:=True;
          LblRS.Caption:='Nome';
          TbCadClienteRG.EditMask:='!###\.###\.###\-##;1;_';
          TbCadClienteCPF.EditMask:='!###\.###\.###\-##;1;_'
      end
end;

procedure TFrmCadCliente.BdcEMailClick(Sender: TObject);
var Mail : String;
begin
If TxtEMailCadCliente.Text='' Then
  Begin
    Application.MessageBox('O sistema no pode encontrar nenhum endereo de e-mail!!!','SC Software',MB_ICONINFORMATION);
    TxtEMailCadCliente.SetFocus;
end
      Else
        If TxtEMailCadCliente.Text<>'' Then
          Begin
            Mail:=TxtEMailCadCliente.Text;
            Mail := 'mailto:'+Mail;
            ShellExecute(GetDesktopWindow,'open',pchar(Mail),nil,nil,sw_ShowNormal);
     end
end;

procedure TFrmCadCliente.TxtLocClienteClick(Sender: TObject);
begin
TxtLocTipoCadClienteClick(Action);
end;

procedure TFrmCadCliente.TxtLocClienteExit(Sender: TObject);
begin
TxtLocTipoCadClienteExit(Action);
end;

procedure TFrmCadCliente.TxtCodCadClienteKeyPress(Sender: TObject;
  var Key: Char);
begin
If Key=#13 Then
  Begin
    SelectNext(ActiveControl,True,True);
    Key:=#0
end
end;

procedure TFrmCadCliente.TxtLocTipoCadClienteKeyPress(Sender: TObject;
  var Key: Char);
begin
If Key=#13 Then
  Begin
    SelectNext(ActiveControl,True,True);
    Key:=#0
end
end;

procedure TFrmCadCliente.TxtRSCadClienteKeyPress(Sender: TObject;
  var Key: Char);
begin
If Key=#13 Then
  Begin
    SelectNext(ActiveControl,True,True);
    Key:=#0
end
end;

procedure TFrmCadCliente.TxtNomeFanCadClienteKeyPress(Sender: TObject;
  var Key: Char);
begin
If Key=#13 Then
  Begin
    SelectNext(ActiveControl,True,True);
    Key:=#0
end
end;

procedure TFrmCadCliente.TxtCNPJCadClienteKeyPress(Sender: TObject;
  var Key: Char);
begin
If Key=#13 Then
  Begin
    SelectNext(ActiveControl,True,True);
    Key:=#0
end
end;

procedure TFrmCadCliente.TxtIECadClienteKeyPress(Sender: TObject;
  var Key: Char);
begin
If Key=#13 Then
  Begin
    SelectNext(ActiveControl,True,True);
    Key:=#0
end
end;

procedure TFrmCadCliente.TxtDCadClienteKeyPress(Sender: TObject;
  var Key: Char);
begin
If Key=#13 Then
  Begin
    SelectNext(ActiveControl,True,True);
    Key:=#0
end
end;

procedure TFrmCadCliente.TxtDNascCadClienteKeyPress(Sender: TObject;
  var Key: Char);
begin
If Key=#13 Then
  Begin
    SelectNext(ActiveControl,True,True);
    Key:=#0
end
end;

procedure TFrmCadCliente.TxtCPFCadClienteKeyPress(Sender: TObject;
  var Key: Char);
begin
If Key=#13 Then
  Begin
    SelectNext(ActiveControl,True,True);
    Key:=#0
end
end;

procedure TFrmCadCliente.TxtRGCadClienteKeyPress(Sender: TObject;
  var Key: Char);
begin
If Key=#13 Then
  Begin
    SelectNext(ActiveControl,True,True);
    Key:=#0
end
end;

procedure TFrmCadCliente.TxtOBSCadClienteKeyPress(Sender: TObject;
  var Key: Char);
begin
If Key=#13 Then
  Begin
    SelectNext(ActiveControl,True,True);
    Key:=#0
end
end;

procedure TFrmCadCliente.TxtEndCadClienteKeyPress(Sender: TObject;
  var Key: Char);
begin
If Key=#13 Then
  Begin
    SelectNext(ActiveControl,True,True);
    Key:=#0
end
end;

procedure TFrmCadCliente.TxtCidadeCadClienteKeyPress(Sender: TObject;
  var Key: Char);
begin
If Key=#13 Then
  Begin
    SelectNext(ActiveControl,True,True);
    Key:=#0
end
end;

procedure TFrmCadCliente.TxtCEPCadClienteKeyPress(Sender: TObject;
  var Key: Char);
begin
If Key=#13 Then
  Begin
    SelectNext(ActiveControl,True,True);
    Key:=#0
end
end;

procedure TFrmCadCliente.TxtFoneCadClienteKeyPress(Sender: TObject;
  var Key: Char);
begin
If Key=#13 Then
  Begin
    SelectNext(ActiveControl,True,True);
    Key:=#0
end
end;

procedure TFrmCadCliente.TxtEMailCadClienteKeyPress(Sender: TObject;
  var Key: Char);
begin
If Key=#13 Then
  Begin
    SelectNext(ActiveControl,True,True);
    Key:=#0
end
end;

procedure TFrmCadCliente.TxtLocUFCadClienteKeyPress(Sender: TObject;
  var Key: Char);
begin
If Key=#13 Then
  Begin
    SelectNext(ActiveControl,True,True);
    Key:=#0
end
end;

procedure TFrmCadCliente.TxtFaxCadClienteKeyPress(Sender: TObject;
  var Key: Char);
begin
If Key=#13 Then
  Begin
    SelectNext(ActiveControl,True,True);
    Key:=#0
end
end;

procedure TFrmCadCliente.FormKeyPress(Sender: TObject; var Key: Char);
begin
If Key=#27 Then
  Begin
    FrmCadCliente.Close;
end
end;

procedure TFrmCadCliente.BdcGerarCodSenKeyPress(Sender: TObject;
  var Key: Char);
begin
If Key=#13 Then
  Begin
    SelectNext(ActiveControl,True,True);
    Key:=#0
end
end;

procedure TFrmCadCliente.BdcSiteClick(Sender: TObject);
var Browser: Variant;
begin
Browser := CreateOleObject('InternetExplorer.Application');
Browser.Visible := True;
Browser.Navigate(TxtSiteCadCliente.Text);
end;

end.
