unit UntCadTS;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DBCtrls, DB, Mask, ADODB, Buttons, ExtCtrls, Grids,
  DBGrids;

type
  TFrmCadTS = class(TForm)
    PnBDCUsu: TPanel;
    BdcNovo: TBitBtn;
    BdcSalvar: TBitBtn;
    BdcAlterar: TBitBtn;
    BdcExcluir: TBitBtn;
    BdcCancelar: TBitBtn;
    PNLocUsu: TPanel;
    Label8: TLabel;
    TxtLocCliente: TDBLookupComboBox;
    TbCadTS: TADOTable;
    TbCadTSCod_Servico: TAutoIncField;
    TbCadTSDescricao: TWideStringField;
    TbCadTSTemp_Garantia: TWideStringField;
    TbCadTSValor: TBCDField;
    TbCadTSValor_S_Imp: TBCDField;
    Label1: TLabel;
    TxtCodTS: TDBEdit;
    DsCadTS: TDataSource;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    TxtVlr: TDBEdit;
    Label5: TLabel;
    TxtImposto: TDBEdit;
    Label6: TLabel;
    TxtSI: TDBEdit;
    TxtDescricao: TDBMemo;
    Label7: TLabel;
    TxtLocTG: TDBComboBox;
    DBGrid1: TDBGrid;
    LogoSoft: TImage;
    LogoSC: TImage;
    TLS: TTimer;
    TLSC: TTimer;
    TbCadTSImposto: TIntegerField;
    TbConsTS: TADOTable;
    AutoIncField1: TAutoIncField;
    WideStringField1: TWideStringField;
    WideStringField2: TWideStringField;
    BCDField1: TBCDField;
    BCDField2: TBCDField;
    IntegerField1: TIntegerField;
    DsConsTS: TDataSource;
    procedure TLSTimer(Sender: TObject);
    procedure TLSCTimer(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TxtImpostoExit(Sender: TObject);
    procedure TxtSIClick(Sender: TObject);
    procedure BdcNovoClick(Sender: TObject);
    procedure BdcSalvarClick(Sender: TObject);
    procedure BdcAlterarClick(Sender: TObject);
    procedure BdcExcluirClick(Sender: TObject);
    procedure BdcCancelarClick(Sender: TObject);
    procedure TxtLocTGKeyPress(Sender: TObject; var Key: Char);
    procedure TxtDescricaoKeyPress(Sender: TObject; var Key: Char);
    procedure TxtCodTSKeyPress(Sender: TObject; var Key: Char);
    procedure TxtVlrKeyPress(Sender: TObject; var Key: Char);
    procedure TxtImpostoKeyPress(Sender: TObject; var Key: Char);
    procedure TxtSIKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmCadTS: TFrmCadTS;

implementation

uses UntSCV;

{$R *.dfm}

procedure TFrmCadTS.TLSTimer(Sender: TObject);
begin
LogoSC.Visible:=False;
LogoSoft.Visible:=True;
TLS.Enabled:=False;
TLSC.Enabled:=True;
end;

procedure TFrmCadTS.TLSCTimer(Sender: TObject);
begin
LogoSoft.Visible:=False;
LogoSC.Visible:=True;
TLSC.Enabled:=False;
TLS.Enabled:=True;
end;

procedure TFrmCadTS.FormShow(Sender: TObject);
begin
TLSC.Enabled:=True;
end;

procedure TFrmCadTS.TxtImpostoExit(Sender: TObject);
begin
If TxtImposto.Text='' Then
  Begin
    Abort;
end
      Else
        TbCadTSValor_S_Imp.AsCurrency:=TbCadTSValor.AsCurrency*TbCadTSImposto.AsFloat/100+TbCadTSValor.AsCurrency;
end;

procedure TFrmCadTS.TxtSIClick(Sender: TObject);
begin
Application.MessageBox('Esse  campo no pode ser alterado!'#13'Voc pode alterar somente os campos Vlr. sem Margem e a Margem de lucro (se existir).','SC Software',MB_ICONINFORMATION);
TxtVlr.SetFocus;
end;

procedure TFrmCadTS.BdcNovoClick(Sender: TObject);
begin
TbCadTS.Active:=True;
TbCadTS.Append;
TxtLocTG.SetFocus;
TxtLocTG.DroppedDown;
BdcNovo.Enabled:=False;
BdcSalvar.Enabled:=True;
BdcAlterar.Enabled:=False;
BdcExcluir.Enabled:=False;
BdcCancelar.Enabled:=True;
TxtLocCliente.Enabled:=False;
end;

procedure TFrmCadTS.BdcSalvarClick(Sender: TObject);
begin
If (TxtLocTG.Text='') or (TxtDescricao.Text='') or (TxtVlr.Text='') or (TxtImposto.Text='') Then
  Begin
    Application.MessageBox('Dados Insuficiente para realizar o cadastro!','SC Software',MB_ICONINFORMATION);
    TxtDescricao.SetFocus;
end
      Else
        Begin
          TbCadTS.Post;
          TbCadTS.Refresh;
          TbCadTS.Active:=False;
          BdcNovo.Enabled:=True;
          BdcSalvar.Enabled:=False;
          BdcAlterar.Enabled:=True;
          BdcExcluir.Enabled:=False;
          BdcCancelar.Enabled:=False;
          TxtLocCliente.Enabled:=False;
          TbConsTS.Active:=False;
          TbConsTS.Active:=True;
      end
end;

procedure TFrmCadTS.BdcAlterarClick(Sender: TObject);
begin
TbCadTS.Active:=True;
TbCadTS.Append;
TbCadTS.Edit;
BdcNovo.Enabled:=False;
BdcSalvar.Enabled:=True;
BdcAlterar.Enabled:=False;
BdcExcluir.Enabled:=True;
BdcCancelar.Enabled:=True;
TxtLocCliente.Enabled:=True;
TxtLocCliente.DropDown;
TxtLocCliente.SetFocus
end;

procedure TFrmCadTS.BdcExcluirClick(Sender: TObject);
begin
If TxtCodTS.Text='' then
  Begin
    Application.MessageBox('No existe cadastro selecionado para ser excluido...'#13'Volte e selecione o cadastro que deseja exluir...','SC Software',MB_ICONINFORMATION);
    TxtLocCliente.DropDown;
    TxtLocCliente.SetFocus;
end
      Else
        If Application.MessageBox('A T E N   O...'#13'Deseja realmente excluir este registro?','SC Software',MB_YESNO+MB_ICONQUESTION)=mrYes then
          Begin
            TbCadTS.Delete;
            Application.MessageBox('Registro excluido com sucesso...','SC Software',MB_ICONINFORMATION);
            TbCadTS.Active:=False;
            BdcNovo.Enabled:=True;
            BdcSalvar.Enabled:=False;
            BdcAlterar.Enabled:=True;
            BdcExcluir.Enabled:=False;
            BdcCancelar.Enabled:=False;
            TxtLocCliente.Enabled:=False;
            TbConsTS.Active:=False;
            TbConsTS.Active:=True;
        end
end;

procedure TFrmCadTS.BdcCancelarClick(Sender: TObject);
begin
If Application.MessageBox('A T E N   O ! ! !'#13'Realmente deseja cancelar esta ao???','SC Software',MB_ICONQUESTION+MB_YESNO)=mrYes Then
  Begin
    TbCadTS.Cancel;
    TbCadTS.Active:=False;
    BdcNovo.Enabled:=True;
    BdcSalvar.Enabled:=False;
    BdcAlterar.Enabled:=True;
    BdcExcluir.Enabled:=False;
    BdcCancelar.Enabled:=False;
    TxtLocCliente.Enabled:=False
end
      Else
        Abort;
end;

procedure TFrmCadTS.TxtLocTGKeyPress(Sender: TObject; var Key: Char);
begin
If Key=#13 Then
  Begin
    SelectNext(ActiveControl,True,True);
    Key:=#0
end
end;

procedure TFrmCadTS.TxtDescricaoKeyPress(Sender: TObject; var Key: Char);
begin
If Key=#13 Then
  Begin
    SelectNext(ActiveControl,True,True);
    Key:=#0
end
end;

procedure TFrmCadTS.TxtCodTSKeyPress(Sender: TObject; var Key: Char);
begin
If Key=#13 Then
  Begin
    SelectNext(ActiveControl,True,True);
    Key:=#0
end
end;

procedure TFrmCadTS.TxtVlrKeyPress(Sender: TObject; var Key: Char);
begin
If Key=#13 Then
  Begin
    SelectNext(ActiveControl,True,True);
    Key:=#0
end
end;

procedure TFrmCadTS.TxtImpostoKeyPress(Sender: TObject; var Key: Char);
begin
If Key=#13 Then
  Begin
    SelectNext(ActiveControl,True,True);
    Key:=#0
end
end;

procedure TFrmCadTS.TxtSIKeyPress(Sender: TObject; var Key: Char);
begin
If Key=#13 Then
  Begin
    SelectNext(ActiveControl,True,True);
    Key:=#0
end
end;

procedure TFrmCadTS.FormKeyPress(Sender: TObject; var Key: Char);
begin
If Key=#27 Then
  Begin
    FrmCadTS.Close;
end
end;

procedure TFrmCadTS.FormClose(Sender: TObject; var Action: TCloseAction);
begin
TbConsTS.Active:=False;
Action:=caFree;
FrmCadTS:=Nil;
end;

end.
