unit UntFormaPgto;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, StdCtrls, Mask, DBCtrls, ADODB, Menus;

type
  TFrmFormaPgto = class(TForm)
    GroupBox1: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    TxtQtdX: TDBEdit;
    TxtInfoXq: TDBEdit;
    TxtCC: TDBEdit;
    TxtNC: TDBEdit;
    TxtBanco: TDBEdit;
    TxtOpPgto: TDBComboBox;
    TxtFormaPgto: TDBComboBox;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label4: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    TxtDesloc: TDBEdit;
    TxtTOS: TDBEdit;
    TxtVlrRec: TDBEdit;
    TxtTroco: TDBEdit;
    TbOSConfPgto: TADOTable;
    TbOSConfPgtoCod_Ordem: TAutoIncField;
    TbOSConfPgtoCod_Cliente: TWideStringField;
    TbOSConfPgtoTOS: TWideStringField;
    TbOSConfPgtoDesc_Equip: TMemoField;
    TbOSConfPgtoDesc_Prob: TMemoField;
    TbOSConfPgtoData_Entrada: TDateTimeField;
    TbOSConfPgtoData_Retirada: TDateTimeField;
    TbOSConfPgtoDeslocamento: TBCDField;
    TbOSConfPgtoValor_Nota: TBCDField;
    TbOSConfPgtoVal_Acrescimo: TBCDField;
    TbOSConfPgtoValor_Nota_1: TBCDField;
    TbOSConfPgtoOPC_Pagamento: TWideStringField;
    TbOSConfPgtoForma_Pagamento: TWideStringField;
    TbOSConfPgtoQtd_Vezes: TWideStringField;
    TbOSConfPgtoInfo_Cheque: TWideStringField;
    TbOSConfPgtoValor_Dinheiro: TBCDField;
    TbOSConfPgtoTroco: TBCDField;
    TbOSConfPgtoTipo_Cartao: TWideStringField;
    TbOSConfPgtoNum_Cartao: TWideStringField;
    TbOSConfPgtoBanco: TWideStringField;
    TbOSConfPgtoConfirma: TBooleanField;
    TbOSConfPgtoAtu_Cont_Rec: TBooleanField;
    DsOSConfPgto: TDataSource;
    MainMenu1: TMainMenu;
    Arquivo1: TMenuItem;
    Confirma: TMenuItem;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ConfirmaClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TxtOpPgtoKeyPress(Sender: TObject; var Key: Char);
    procedure TxtFormaPgtoKeyPress(Sender: TObject; var Key: Char);
    procedure TxtDeslocKeyPress(Sender: TObject; var Key: Char);
    procedure TxtVlrRecKeyPress(Sender: TObject; var Key: Char);
    procedure TxtTrocoEnter(Sender: TObject);
    procedure TxtTrocoClick(Sender: TObject);
    procedure TxtTOSClick(Sender: TObject);
    procedure TxtTOSEnter(Sender: TObject);
    procedure TxtOpPgtoExit(Sender: TObject);
    procedure TxtVlrRecExit(Sender: TObject);
    procedure TxtDeslocExit(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmFormaPgto: TFrmFormaPgto;

implementation

uses UntSCV, UntOS, UntQrepAbertOS;

{$R *.dfm}

procedure TFrmFormaPgto.FormKeyPress(Sender: TObject; var Key: Char);
begin
If KEY='27' Then
  Begin
    FrmFormaPgto.Close;
end;
end;

procedure TFrmFormaPgto.ConfirmaClick(Sender: TObject);
begin
If (TxtOpPgto.Text='') or (TxtVlrRec.Text='') Then
  Begin
    Application.MessageBox('Dados insuficiente para confirmar a forma de pagamento!','SC Software',MB_ICONEXCLAMATION);
    TxtOpPgto.DroppedDown:=True;
    TxtOpPgto.SetFocus;
end
      Else
        Begin
          TbOSConfPgtoConfirma.Value:=True;
          TbOSConfPgto.Post;
          TbOSConfPgto.Refresh;
          QRAbertOS.TbQrepAberOS.Active:=True;
          QRAbertOS.TbCliente.Active:=True;
          QRAbertOS.TbItemServico.Active:=True;
          QRAbertOS.TbQrepAberOS.Filtered:=True;
         // QRAbertOS.TbItemServico.Filtered:=True;
 //         QRAbertOS.TbCliente.Filtered:=True;
          QRAbertOS.TbQrepAberOS.Filter:='Cod_Ordem='+QuotedStr(FrmOS.TxtCodOS.Text);
        //  QRAbertOS.TbCliente.Filter:='Nome='+QuotedStr(FrmOS.DBEdit4.Text);
       //   QRAbertOS.TbItemServico.Filter:='Cod_Ordem='+QuotedStr(FrmOS.TxtCodOS.Text);
          QRAbertOS.Preview;
          FrmOS.Close;
          FrmFormaPgto.Close;
       //   QRAbertOS.Preview;
      end
end;

procedure TFrmFormaPgto.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
Action:=caFree;
FrmFormaPgto:=Nil;
end;

procedure TFrmFormaPgto.TxtOpPgtoKeyPress(Sender: TObject; var Key: Char);
begin
If Key=#13 Then
  Begin
    SelectNext(ActiveControl,True,True);
    Key:=#0
end
end;

procedure TFrmFormaPgto.TxtFormaPgtoKeyPress(Sender: TObject;
  var Key: Char);
begin
If Key=#13 Then
  Begin
    SelectNext(ActiveControl,True,True);
    Key:=#0
end
end;

procedure TFrmFormaPgto.TxtDeslocKeyPress(Sender: TObject; var Key: Char);
begin
If Key=#13 Then
  Begin
    SelectNext(ActiveControl,True,True);
    Key:=#0
end
end;

procedure TFrmFormaPgto.TxtVlrRecKeyPress(Sender: TObject; var Key: Char);
begin
If Key=#13 Then
  Begin
    SelectNext(ActiveControl,True,True);
    Key:=#0
end
end;

procedure TFrmFormaPgto.TxtTrocoEnter(Sender: TObject);
begin
TxtVlrRec.SetFocus;
end;

procedure TFrmFormaPgto.TxtTrocoClick(Sender: TObject);
begin
TxtVlrRec.SetFocus;
end;

procedure TFrmFormaPgto.TxtTOSClick(Sender: TObject);
begin
TxtVlrRec.SetFocus;
end;

procedure TFrmFormaPgto.TxtTOSEnter(Sender: TObject);
begin
TxtVlrRec.SetFocus;
end;

procedure TFrmFormaPgto.TxtOpPgtoExit(Sender: TObject);
begin
If TxtOpPgto.Text='A PRAZO' Then
  Begin
    Application.MessageBox('OS a prazo no esta disponvel no momento...','SC Software',MB_ICONEXCLAMATION);
    TxtOpPgto.DroppedDown:=True;
    TxtOpPgto.SetFocus;
end
      Else
        Abort;
end;

procedure TFrmFormaPgto.TxtVlrRecExit(Sender: TObject);
begin
If TxtVlrRec.Text>TxtTOS.Text Then
  Begin
    TbOSConfPgtoTroco.AsCurrency:=TbOSConfPgtoValor_Dinheiro.AsCurrency-TbOSConfPgtoValor_Nota_1.AsCurrency;
end
      Else
        Begin
          TxtTroco.Text:='R$0,00';
      end;
end;

procedure TFrmFormaPgto.TxtDeslocExit(Sender: TObject);
begin
If TxtDesloc.Text<>'R$0,00' Then
  Begin
    TbOSConfPgtoValor_Nota_1.AsCurrency:=TbOSConfPgtoValor_Nota_1.AsCurrency+TbOSConfPgtoDeslocamento.AsCurrency;
end
      Else
        Abort;
end;

end.
