unit UntLogin;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, StdCtrls, DBCtrls, Buttons, Mask, ExtCtrls, DBTables, ADODB;

type
  TFrmLogin = class(TForm)
    PnLogin: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label6: TLabel;
    TxtNome: TDBEdit;
    TxtAcesso: TDBEdit;
    BdcEntrar: TBitBtn;
    BdcCancelar: TBitBtn;
    TxtLocUsoLogin: TDBLookupComboBox;
    EdSenha: TEdit;
    TxtSenha: TDBEdit;
    DsUsoLogin: TDataSource;
    TbUsu: TADOTable;
    TbUsuCodigo: TAutoIncField;
    TbUsuNome: TWideStringField;
    TbUsuLogin: TWideStringField;
    TbUsuSenha: TWideStringField;
    TbUsuConfSenha: TWideStringField;
    TbUsuAcesso: TWideStringField;
    TbUsuStatus: TWideStringField;
    Verifica: TTimer;
    procedure BdcEntrarClick(Sender: TObject);
    procedure BdcCancelarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure TxtLocUsoLoginKeyPress(Sender: TObject; var Key: Char);
    procedure EdSenhaKeyPress(Sender: TObject; var Key: Char);
    procedure VerificaTimer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmLogin: TFrmLogin;
  T: integer;
implementation

uses UntPrincipal, UntSCV;

{$R *.dfm}

procedure TFrmLogin.BdcEntrarClick(Sender: TObject);
begin
If TxtLocUsoLogin.Text='' Then
  Begin
    Application.MessageBox('O login do usurio deve ser informado!','SC Software',MB_ICONINFORMATION);
    TxtLocUsoLogin.DropDown;
    TxtLocUsoLogin.SetFocus;
end
      Else
        If EdSenha.Text='' then
          Begin
            Application.MessageBox('A senha do usurio deve ser informada...','SC Software',MB_ICONINFORMATION);
            EdSenha.SetFocus;
      end
              Else
                If EdSenha.Text<>TxtSenha.Text then
                  Begin
                    Application.MessageBox('A senha do usurio esta incorreta...'#13'Redigite a senha ou entre em contato com o administrador...','SC Software',MB_ICONERROR);
                    T:=T + 1;
                    EdSenha.SetFocus;
                    EdSenha.Clear;
              end
      Else
        If EdSenha.Text=TxtSenha.Text then
          Begin
            TbUsu.Edit;
            TbUsu.FieldValues['Status']:='ONLINE';
            TbUsu.Post;
            Application.CreateForm(TFrmPrincipal,FrmPrincipal);
            FrmPrincipal.Show;
            FrmPrincipal.StatusBar.Panels[1].Text:=FrmLogin.TxtLocUsoLogin.Text;
            FrmPrincipal.StatusBar.Panels[3].Text:=FrmLogin.TxtAcesso.Text;
            FrmLogin.Close;
  end
end;

procedure TFrmLogin.BdcCancelarClick(Sender: TObject);
begin
Application.Terminate;
end;

procedure TFrmLogin.FormClose(Sender: TObject; var Action: TCloseAction);
begin
TbUsu.Active:=False;
Action:=caFree;
FrmLogin:=Nil;
end;

procedure TFrmLogin.FormActivate(Sender: TObject);
Var
  T:Integer;
  A:Integer;
  F:Integer;
begin
TbUsu.Active:=True;
TbUsu.Append;
T:=0;
Verifica.Enabled:=True;
end;

procedure TFrmLogin.TxtLocUsoLoginKeyPress(Sender: TObject; var Key: Char);
begin
If Key=#13 then
  Begin
    SelectNext(ActiveControl,True,True);
    Key:=#0
end
end;

procedure TFrmLogin.EdSenhaKeyPress(Sender: TObject; var Key: Char);
begin
If Key=#13 then
  Begin
    SelectNext(ActiveControl,True,True);
    Key:=#0
end
end;

procedure TFrmLogin.VerificaTimer(Sender: TObject);
begin
If T >= 3 Then
  Begin
    Verifica.Enabled:=False;
    Application.MessageBox('Tentativas de acesso excedidas.'#13'Precione a tecla Enter ou clique em Ok para encerrar.','SC Software',MB_ICONEXCLAMATION);
    Application.Terminate;
end
    Else
      Begin
        Abort;
    end;
end;

end.
