unit UntModuloDados;

interface

uses
  SysUtils, Classes, DB, ADODB, RpCon, RpConDS, RpDefine, RpRave, ExtCtrls,
  DBTables, DBIProcs;

type
  TDataModulos = class(TDataModule)
    TbUsu: TTable;
    TbCadGrp: TTable;
    TbUsuIDUsuario: TAutoIncField;
    TbUsuNome: TStringField;
    TbUsuLogin: TStringField;
    TbUsuSenha: TStringField;
    TbUsuConfirma: TStringField;
    TbUsuDepartamento: TStringField;
    TbUsuAcesso: TStringField;
    TbCadProd: TTable;
    TbCadGrpIDGrupo: TAutoIncField;
    TbCadGrpDescricao: TStringField;
    TbPedComp: TTable;
    TbItemPedComp: TTable;
    TbItemPedCompIdPedidoCompraItem: TIntegerField;
    TbItemPedCompIdProdutoItem: TIntegerField;
    TbItemPedCompDescricaoItem: TStringField;
    TbItemPedCompVlrCompraItem: TCurrencyField;
    TbItemPedCompQutCompraItem: TFloatField;
    TbItemPedCompTotalItem: TCurrencyField;
    TbCadProdIDProduto: TIntegerField;
    TbCadProdGrupo: TStringField;
    TbCadProdFornecedor: TStringField;
    TbCadProdDescricao: TStringField;
    TbCadProdVlrCompra: TCurrencyField;
    TbCadProdMargen: TFloatField;
    TbCadProdVlrVenda: TCurrencyField;
    TbCadProdUnidade: TStringField;
    TbCadProdReposicao: TFloatField;
    TbCadProdEstoque: TFloatField;
    TbCadCliente: TTable;
    TbCadClienteCodigo_Cliente: TAutoIncField;
    TbCadClienteData_Cad: TDateField;
    TbCadClientePF_PJ: TStringField;
    TbCadClienteNome: TStringField;
    TbCadClienteData_Nascimento: TDateField;
    TbCadClienteCPF: TStringField;
    TbCadClienteIE: TStringField;
    TbCadClienteCGC: TStringField;
    TbCadClienteRazao_Social: TStringField;
    TbCadClienteRG: TStringField;
    TbCadClienteFone: TStringField;
    TbCadClienteFax: TStringField;
    TbCadClienteE_Mail: TStringField;
    TbCadClienteSite: TStringField;
    TbCadClienteEndereco: TStringField;
    TbCadClienteCidade: TStringField;
    TbCadClienteCEP: TStringField;
    TbCadClienteUF: TStringField;
    TbCadClienteObs: TStringField;
    TbCadClienteUser: TStringField;
    TbCadClienteSenha: TStringField;
    TbCadFornecedor: TTable;
    TbCadFuncionario: TTable;
    TbCadFuncionarioCodigo_Func: TAutoIncField;
    TbCadFuncionarioData_Cad: TDateField;
    TbCadFuncionarioNome: TStringField;
    TbCadFuncionarioProfissao: TStringField;
    TbCadFuncionarioSexo: TStringField;
    TbCadFuncionarioEstado_Civil: TStringField;
    TbCadFuncionarioData_Nascimento: TDateField;
    TbCadFuncionarioNacionalidade: TStringField;
    TbCadFuncionarioRG: TStringField;
    TbCadFuncionarioOrg_Emissor: TStringField;
    TbCadFuncionarioData_Emissao: TDateField;
    TbCadFuncionarioCPF: TStringField;
    TbCadFuncionarioFone: TStringField;
    TbCadFuncionarioE_Mail: TStringField;
    TbCadFuncionarioEndereco: TStringField;
    TbCadFuncionarioBairro: TStringField;
    TbCadFuncionarioCidade: TStringField;
    TbCadFuncionarioCEP: TStringField;
    TbCadFuncionarioUF: TStringField;
    TbCadFuncionarioObs: TStringField;
    TbCadFuncionarioCodigo: TStringField;
    TbCadFuncionarioSenha: TStringField;
    TbItemPedCompBaixado: TStringField;
    TbVenda: TTable;
    TbItemVenda: TTable;
    TbVendaIdPedidoVenda: TAutoIncField;
    TbVendaDataVenda: TDateField;
    TbVendaCliente: TStringField;
    TbVendaCondicaoPagamento: TStringField;
    TbVendaNParcela: TFloatField;
    TbVendaVlrParcela: TCurrencyField;
    TbVendaDesconto: TCurrencyField;
    TbVendaTotalVenda: TCurrencyField;
    TbItemVendaIdPedidoVendaItem: TIntegerField;
    TbItemVendaIdProdutoItem: TIntegerField;
    TbItemVendaDescricaoItem: TStringField;
    TbItemVendaVlrVendaItem: TCurrencyField;
    TbItemVendaQutVendaItem: TFloatField;
    TbItemVendaTotalItem: TCurrencyField;
    TbCadFornecedorCodigo_Fornecedor: TAutoIncField;
    TbCadFornecedorData_Cad: TDateField;
    TbCadFornecedorPF_PJ: TStringField;
    TbCadFornecedorNome: TStringField;
    TbCadFornecedorCPF: TStringField;
    TbCadFornecedorIE: TStringField;
    TbCadFornecedorCGC: TStringField;
    TbCadFornecedorRazao_Social: TStringField;
    TbCadFornecedorRG: TStringField;
    TbCadFornecedorFone: TStringField;
    TbCadFornecedorFax: TStringField;
    TbCadFornecedorE_Mail: TStringField;
    TbCadFornecedorSite: TStringField;
    TbCadFornecedorEndereco: TStringField;
    TbCadFornecedorCidade: TStringField;
    TbCadFornecedorCEP: TStringField;
    TbCadFornecedorUF: TStringField;
    TbCadFornecedorObs: TStringField;
    TbPedCompIdPedidoCompra: TAutoIncField;
    TbPedCompDataPedidoCompra: TDateField;
    TbPedCompFornecedor: TStringField;
    TbPedCompCondicaoPagamento: TStringField;
    TbPedCompNParcela: TFloatField;
    TbPedCompVlrParcela: TCurrencyField;
    TbPedCompDesconto: TCurrencyField;
    TbPedCompTotalCompra: TCurrencyField;
    TbPedCompBaixado: TStringField;
    TbVendaBaixado: TStringField;
    TbUsuStatus: TStringField;
    TbSistema: TTable;
    TbSistemaCod: TAutoIncField;
    TbSistemaUsuario: TStringField;
    TbSistemaDepartamento: TStringField;
    TbSistemaNivel: TStringField;
    TbSistemaComputador: TStringField;
    TbSistemaIP: TStringField;
    TbSistemaData: TDateField;
    TbSistemaHEntrada: TTimeField;
    TbSistemaHSaida: TTimeField;
    TbSistemaTempoEstimado: TTimeField;
    TbSistemaFormsMex: TBlobField;
    TbSistemaConsEfet: TBlobField;
    TbCadEmpresa: TTable;
    TbCadEmpresaNome_Fantasi: TStringField;
    TbCadEmpresaRazao_Social: TStringField;
    TbCadEmpresaCNPJ: TStringField;
    TbCadEmpresaIE: TStringField;
    TbCadEmpresaEndereco: TStringField;
    TbCadEmpresaCidade: TStringField;
    TbCadEmpresaBairro: TStringField;
    TbCadEmpresaCep: TStringField;
    TbCadEmpresaUF: TStringField;
    TbCadEmpresaFone: TStringField;
    TbCadEmpresaFax: TStringField;
    TbCadEmpresaOutro: TStringField;
    TbCadEmpresaEmail: TStringField;
    TbCadEmpresaSite: TStringField;
    TbCadEmpresaLogo: TBlobField;
    TbCadEmpresaSerial: TStringField;
    TbCadEmpresaArea: TBlobField;
    TbCaixa: TTable;
    TbCaixaCodigo: TAutoIncField;
    TbCaixaData: TDateField;
    TbCaixaCpVista: TCurrencyField;
    TbCaixaFPagas: TCurrencyField;
    TbCaixaTSaida: TCurrencyField;
    TbCaixaVVista: TCurrencyField;
    TbCaixaFRecebidas: TCurrencyField;
    TbCaixaTRecebidas: TCurrencyField;
    TbCaixaStatus: TStringField;
    TbCaixaFechado: TStringField;
    TbCaixaSaldoDia: TCurrencyField;
    TbCaixaSaldoDiaAnterior: TCurrencyField;
    TbCaixaSaldoCaixa: TCurrencyField;
    procedure TbUsuAfterPost(DataSet: TDataSet);
    procedure TbCadGrpAfterPost(DataSet: TDataSet);
    procedure TbCadProdAfterPost(DataSet: TDataSet);
    procedure TbPedCompAfterPost(DataSet: TDataSet);
    procedure TbItemPedCompAfterPost(DataSet: TDataSet);
    procedure TbCadClienteAfterPost(DataSet: TDataSet);
    procedure TbCadFornecedorAfterPost(DataSet: TDataSet);
    procedure TbCadFuncionarioAfterPost(DataSet: TDataSet);
    procedure TbVendaAfterPost(DataSet: TDataSet);
    procedure TbItemVendaAfterPost(DataSet: TDataSet);
    procedure TbSistemaAfterPost(DataSet: TDataSet);
    procedure TbCaixaAfterPost(DataSet: TDataSet);
    procedure TbCaixaAfterOpen(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DataModulos: TDataModulos;

implementation


{$R *.dfm}

procedure TDataModulos.TbUsuAfterPost(DataSet: TDataSet);
begin
DBISaveChanges(TbUsu.Handle);
end;

procedure TDataModulos.TbCadGrpAfterPost(DataSet: TDataSet);
begin
DBISaveChanges(TbCadGrp.Handle);
end;

procedure TDataModulos.TbCadProdAfterPost(DataSet: TDataSet);
begin
DBISaveChanges(TbCadProd.Handle);
end;

procedure TDataModulos.TbPedCompAfterPost(DataSet: TDataSet);
begin
DBISaveChanges(TbPedComp.Handle);
end;

procedure TDataModulos.TbItemPedCompAfterPost(DataSet: TDataSet);
begin
DBISaveChanges(TbItemPedComp.Handle);
end;

procedure TDataModulos.TbCadClienteAfterPost(DataSet: TDataSet);
begin
DBISaveChanges(TbCadCliente.Handle);
end;

procedure TDataModulos.TbCadFornecedorAfterPost(DataSet: TDataSet);
begin
DBISaveChanges(TbCadFornecedor.Handle);
end;

procedure TDataModulos.TbCadFuncionarioAfterPost(DataSet: TDataSet);
begin
DBISaveChanges(TbCadFuncionario.Handle);
end;

procedure TDataModulos.TbVendaAfterPost(DataSet: TDataSet);
begin
DBISaveChanges(TbVenda.Handle);
end;

procedure TDataModulos.TbItemVendaAfterPost(DataSet: TDataSet);
begin
DBISaveChanges(TbItemVenda.Handle);
end;

procedure TDataModulos.TbSistemaAfterPost(DataSet: TDataSet);
begin
DBISaveChanges(TbSistema.Handle);
end;

procedure TDataModulos.TbCaixaAfterPost(DataSet: TDataSet);
begin
DBISaveChanges(TbCaixa.Handle);
end;

procedure TDataModulos.TbCaixaAfterOpen(DataSet: TDataSet);
begin
If not TbCaixa.Locate('Data',DateToStr(Date),[]) Then
  Begin
    TbCaixa.Active:=True;
    TbCaixa.Append;
    TbCaixaData.Text:=DateToStr(Date);
    TbCaixa.Post;
end
      Else
        Begin
          TbCaixa.Cancel;
      end;
end;

end.
