unit UntOS;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DBCtrls, Grids, DBGrids, DB, StdCtrls, Mask, ADODB, Menus,
  ExtCtrls;

type
  TFrmOS = class(TForm)
    TbOS: TADOTable;
    TbOSCod_Ordem: TAutoIncField;
    TbOSCod_Cliente: TWideStringField;
    TbOSDesc_Equip: TMemoField;
    TbOSDesc_Prob: TMemoField;
    TbOSData_Entrada: TDateTimeField;
    TbOSData_Retirada: TDateTimeField;
    TbOSDeslocamento: TBCDField;
    TbOSValor_Nota: TBCDField;
    TbOSVal_Acrescimo: TBCDField;
    TbOSValor_Nota_1: TBCDField;
    TbOSOPC_Pagamento: TWideStringField;
    TbOSForma_Pagamento: TWideStringField;
    TbOSQtd_Vezes: TWideStringField;
    TbOSInfo_Cheque: TWideStringField;
    TbOSValor_Dinheiro: TBCDField;
    TbOSTroco: TBCDField;
    TbOSTipo_Cartao: TWideStringField;
    TbOSNum_Cartao: TWideStringField;
    TbOSBanco: TWideStringField;
    TbOSConfirma: TBooleanField;
    TbOSAtu_Cont_Rec: TBooleanField;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    TxtCodOS: TDBEdit;
    DsOS: TDataSource;
    Label2: TLabel;
    DBEdit2: TDBEdit;
    Label3: TLabel;
    DBEdit3: TDBEdit;
    Label4: TLabel;
    DBEdit4: TDBEdit;
    TbItemOS: TADOTable;
    DsItemOS: TDataSource;
    TbItemOSCod_Iten_Ordem: TAutoIncField;
    TbItemOSCod_Ordem: TIntegerField;
    TbItemOSCod_Produto: TIntegerField;
    TbItemOSNome: TWideStringField;
    TbItemOSUnd: TWideStringField;
    TbItemOSUnidade: TWideStringField;
    TbItemOSQtd_Und: TWideStringField;
    TbItemOSVal_Unit: TBCDField;
    TbItemOSQtd: TFloatField;
    TbItemOSInfo_Adic: TMemoField;
    TbItemOSSub_Total: TBCDField;
    TbItemOSAtualizado: TBooleanField;
    TbItemOSP: TBooleanField;
    TbItemOSSV: TBooleanField;
    GroupBox2: TGroupBox;
    DBGItemOS: TDBGrid;
    TbProOS: TADOTable;
    DsProOS: TDataSource;
    MainMenu1: TMainMenu;
    Arquivo1: TMenuItem;
    Fechar: TMenuItem;
    Opes1: TMenuItem;
    Inserir: TMenuItem;
    Salvar: TMenuItem;
    Cancelar: TMenuItem;
    TbProOSCod_Servico: TAutoIncField;
    TbProOSDescricao: TWideStringField;
    TbProOSTemp_Garantia: TWideStringField;
    TbProOSValor: TBCDField;
    TbProOSImposto: TIntegerField;
    TbProOSValor_S_Imp: TBCDField;
    TbItemOSGarantia: TWideStringField;
    GerarParcelas: TMenuItem;
    N1: TMenuItem;
    OpodePagamento: TMenuItem;
    N2: TMenuItem;
    GroupBox3: TGroupBox;
    Label5: TLabel;
    DBEdit5: TDBEdit;
    PopupMenu1: TPopupMenu;
    ExcluirServio1: TMenuItem;
    Virifica: TTimer;
    ExcluirServio: TMenuItem;
    Panel2: TPanel;
    Panel1: TPanel;
    Image1: TImage;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FecharClick(Sender: TObject);
    procedure InserirClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure DBEdit2Click(Sender: TObject);
    procedure DBEdit4Click(Sender: TObject);
    procedure TxtCodOSClick(Sender: TObject);
    procedure ExcluirServio1Click(Sender: TObject);
    procedure VirificaTimer(Sender: TObject);
    procedure ExcluirServioClick(Sender: TObject);
    procedure SalvarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Image1Click(Sender: TObject);
    procedure OpodePagamentoClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmOS: TFrmOS;
  Liberado:String;

implementation

uses UntSCV, UnIncItenCompra, UntConclusaoOS, UntFormaPgto;

{$R *.dfm}
{ Para excluir servio}
function PasswordInputBox(const ACaption, APrompt:string): string;
var
  Form: TForm;
  Prompt: TLabel;
  Edit: TEdit;
  DialogUnits: TPoint;
  ButtonTop, ButtonWidth, ButtonHeight: Integer;
  Value: string;
  I: Integer;
  Buffer: array[0..51] of Char;
begin
  Result := '';
  Form := TForm.Create(Application);
  with Form do
  try
    Canvas.Font := Font;
    for I := 0 to 25 do Buffer[I] := Chr(I + Ord('A'));
    for I := 0 to 25 do Buffer[I + 26] := Chr(I + Ord('a'));
    GetTextExtentPoint(Canvas.Handle, Buffer, 52, TSize(DialogUnits));
    DialogUnits.X := DialogUnits.X div 52;
    BorderStyle := bsDialog;
    Caption := ACaption;
    ClientWidth := MulDiv(180, DialogUnits.X, 4);
    ClientHeight := MulDiv(63, DialogUnits.Y, 8);
    Position := poScreenCenter;
    Prompt := TLabel.Create(Form);
    with Prompt do
    begin
      Parent := Form;
      AutoSize := True;
      Left := MulDiv(8, DialogUnits.X, 4);
      Top := MulDiv(8, DialogUnits.Y, 8);
      Caption := APrompt;
    end;
    Edit := TEdit.Create(Form);
    with Edit do
    begin
      Parent := Form;
      Left := Prompt.Left;
      Top := MulDiv(19, DialogUnits.Y, 8);
      Width := MulDiv(164, DialogUnits.X, 4);
      MaxLength := 255;
      PasswordChar := '*';
      SelectAll;
    end;
    ButtonTop := MulDiv(41, DialogUnits.Y, 8);
    ButtonWidth := MulDiv(50, DialogUnits.X, 4);
    ButtonHeight := MulDiv(14, DialogUnits.Y, 8);
    with TButton.Create(Form) do
    begin
      Parent := Form;
      Caption := 'Liberar';
      ModalResult := mrOk;
      Default := True;
      SetBounds(MulDiv(38, DialogUnits.X, 4),ButtonTop, ButtonWidth,ButtonHeight);
    end;
    with TButton.Create(Form) do
    begin
      Parent := Form;
      Caption := 'Cancelar';
      ModalResult := mrCancel;
      Cancel := True;
      SetBounds(MulDiv(92, DialogUnits.X, 4),ButtonTop, ButtonWidth,ButtonHeight);
    end;
    if ShowModal = mrOk then
    begin
      Value := Edit.Text;
      Result := Value;
     end;
  finally
    Form.Free;
    Form:=nil;
     end;
 end;
{Fim do procedimento de excluir servio}

procedure TFrmOS.FormKeyPress(Sender: TObject; var Key: Char);
begin
If Key=#27 Then
  Begin
    FrmOS.Close;
end
end;

procedure TFrmOS.FecharClick(Sender: TObject);
begin
FrmOS.Close;
end;

procedure TFrmOS.InserirClick(Sender: TObject);
begin
Application.CreateForm(TFrmIncluirItenComp,FrmIncluirItenComp);
Inserir.Enabled:=False;
Salvar.Enabled:=True;
Cancelar.Enabled:=True;
FrmIncluirItenComp.ShowModal;
end;

procedure TFrmOS.FormShow(Sender: TObject);
begin
FrmConclusaoOS.Close;
If TxtCodOS.Text='' Then
  Begin
    Application.MessageBox('Ordem de Servio no encontrada!!!'#13'Tente novamente mais tarde','SC Software',MB_ICONERROR);
    FrmOS.Close;
end
      Else
        Begin
          Liberado:='No';
      end
end;

procedure TFrmOS.DBEdit2Click(Sender: TObject);
begin
DBEdit3.SetFocus;
end;

procedure TFrmOS.DBEdit4Click(Sender: TObject);
begin
DBEdit3.SetFocus;
end;

procedure TFrmOS.TxtCodOSClick(Sender: TObject);
begin
DBEdit3.SetFocus;
end;

procedure TFrmOS.ExcluirServio1Click(Sender: TObject);
begin
if PasswordInputBox('rea restrita','Digite sua senha:') = 'thehacker' then  // Aqui chama a funo, caso a senha esteja correta abre o form
   Try
  Liberado:='Sim';
  ExcluirServio.Visible:=True;
  ExcluirServio.Enabled:=True;
  Finally

       end
    else
    if Application.MessageBox('Senha invlida!'+#13+ 'Voc tem mais 2 tentativas!', 'SC Software' ,mb_iconexclamation + mb_OK)= idOK then  //se senha errada mostra aviso de tentativas.
    if PasswordInputBox('rea restrita','Digite sua senha:') = 'thehacker' then
    begin
    try
     Liberado:='Sim';
     ExcluirServio.Visible:=True;
     ExcluirServio.Enabled:=True;
   Finally

           end
       end
    else
    if Application.MessageBox('Senha invlida!'+#13+ 'ltima tentativa!', 'SC Software' ,mb_iconexclamation + mb_OK)= idOK then  //senha errada fecha o ImputBox.
    if PasswordInputBox('rea restrita','Digite sua senha:') = 'thehacker' then
    begin
     Try
  Finally
     end;
  end;
end;

procedure TFrmOS.VirificaTimer(Sender: TObject);
begin
If Liberado='Sim' Then
  Begin
    Virifica.Enabled:=False;
    ExcluirServio.Visible:=True;
    ExcluirServio.Enabled:=True;
    Application.MessageBox('Usurio liberado para excluir item(ns) da OS.','SC Software',MB_ICONASTERISK);
end
      Else
        Abort;
end;

procedure TFrmOS.ExcluirServioClick(Sender: TObject);
begin
If Application.MessageBox('A T E N   O ! ! !'#13'Deseja excluir o servio da OS ??','SC Informtica',MB_YESNO+MB_ICONQUESTION)=mrYes then
  Begin
    TbOS.Edit;
    TbOSValor_Nota_1.AsCurrency:=TbOSValor_Nota_1.AsCurrency-TbItemOSVal_Unit.AsCurrency;
    TbOS.Post;
    TbOS.Refresh;
    TbItemOS.Edit;
    TbItemOS.Delete;
    TbItemOS.Refresh;
end
      Else
        Begin
          Abort;
      end
end;

procedure TFrmOS.SalvarClick(Sender: TObject);
Var
  Cod:String;
begin
If Application.MessageBox('Voc confirma esta Ordem de Servio ???'#13#13'Obs. Uma vez confirmada a OS, voc no poder cancelar ou incluir novos servios.'#13'S clique em "SIM" se tiver ceteza que no necessitar alterar os servios !!!','SC Software',MB_YESNO+MB_ICONQUESTION)=mrYes Then
  Begin
    Application.MessageBox('Ordem de Servio confirmada.'#13'Cadastre agora as condies de pagamento.','SC Software',MB_ICONINFORMATION);
    TbOS.Edit;
    TbOSData_Retirada.Value:=Date;
    Cod:=TxtCodOS.Text;
    TbOS.Post;
    TbOS.Refresh;
    TbOS.Filtered:=True;
    TbOS.Filter:='Cod_Ordem='+QuotedStr(Cod);
    OpodePagamento.Enabled:=True;
    OpodePagamento.Click;
end
      Else
        Abort;
end;

procedure TFrmOS.FormClose(Sender: TObject; var Action: TCloseAction);
begin
Action:=caFree;
FrmOS:=Nil;
end;

procedure TFrmOS.Image1Click(Sender: TObject);
begin
Application.MessageBox('--------------------------------------------------------'#13+
                       '                 TECLAS DE ATALHO                       '#13+
                       '--------------------------------------------------------'#13+
                       ' F2 - Incluir servios'#13+
                       ' F3 - Confirma Ordem de Servio'#13+
                       ' F4 - Cancela e fecha o formulrio de OS'#13+
                       'F11 - Excluir servios'#13#13+
                       ' F6 - Opes de Pagamento'#13+
                       ' F8 - Gerar Parcelas'#13#13+
                       '--------------------------------------------------------'#13#13+
                       'SC Software'#13+
                       'scsoftware@hotmail.com'#13+
                       'www.scsoftware.weebly.com'#13#13+
                       '--------------------------------------------------------','Software',MB_ICONINFORMATION);
end;

procedure TFrmOS.OpodePagamentoClick(Sender: TObject);
begin
Application.CreateForm(TFrmFormaPgto,FrmFormaPgto);
FrmFormaPgto.TbOSConfPgto.Filtered:=True;
FrmFormaPgto.TbOSConfPgto.Filter:='Cod_Ordem='+QuotedStr(TxtCodOS.Text);
FrmFormaPgto.ShowModal;
end;

end.
