unit UntAbertOS;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, StdCtrls, DBCtrls, Mask, ADODB, Buttons, ExtCtrls;

type
  TFrmAbrtOS = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    TxtCodOS: TDBEdit;
    TxtCliente: TDBEdit;
    TxtDescEquip: TDBMemo;
    TxtDescProb: TDBMemo;
    TxtDtEntrada: TDBEdit;
    TbAbrtOS: TADOTable;
    DsAbrtOS: TDataSource;
    SBCliente: TSpeedButton;
    PnBDCUsu: TPanel;
    BdcSalvar: TBitBtn;
    BdcNovo: TBitBtn;
    BdcImprimir: TBitBtn;
    Label6: TLabel;
    TbAbrtOSCod_Ordem: TAutoIncField;
    TbAbrtOSCod_Cliente: TWideStringField;
    TbAbrtOSTOS: TWideStringField;
    TbAbrtOSDesc_Equip: TMemoField;
    TbAbrtOSDesc_Prob: TMemoField;
    TbAbrtOSData_Entrada: TDateTimeField;
    TbAbrtOSData_Retirada: TDateTimeField;
    TbAbrtOSDeslocamento: TBCDField;
    TbAbrtOSValor_Nota: TBCDField;
    TbAbrtOSVal_Acrescimo: TBCDField;
    TbAbrtOSValor_Nota_1: TBCDField;
    TbAbrtOSOPC_Pagamento: TWideStringField;
    TbAbrtOSForma_Pagamento: TWideStringField;
    TbAbrtOSQtd_Vezes: TWideStringField;
    TbAbrtOSInfo_Cheque: TWideStringField;
    TbAbrtOSValor_Dinheiro: TBCDField;
    TbAbrtOSTroco: TBCDField;
    TbAbrtOSTipo_Cartao: TWideStringField;
    TbAbrtOSNum_Cartao: TWideStringField;
    TbAbrtOSBanco: TWideStringField;
    TbAbrtOSConfirma: TBooleanField;
    TbAbrtOSAtu_Cont_Rec: TBooleanField;
    TxtLocTOS: TDBComboBox;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure BdcNovoClick(Sender: TObject);
    procedure BdcSalvarClick(Sender: TObject);
    procedure SBClienteClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TxtClienteEnter(Sender: TObject);
    procedure BdcImprimirClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmAbrtOS: TFrmAbrtOS;

implementation

uses UntSCV, UntListCliente, UntQrepAbertOS;

{$R *.dfm}

procedure TFrmAbrtOS.FormKeyPress(Sender: TObject; var Key: Char);
begin
If Key=#27 Then
  Begin
    FrmAbrtOS.Close;
end
end;

procedure TFrmAbrtOS.BdcNovoClick(Sender: TObject);
begin
TbAbrtOS.Active:=True;
TbAbrtOS.Append;
TbAbrtOSData_Entrada.Value:=Date;
TxtLocTOS.SetFocus;
TxtLocTOS.DroppedDown:=True;
BdcNovo.Enabled:=False;
BdcSalvar.Enabled:=True;
BdcImprimir.Enabled:=False;

end;

procedure TFrmAbrtOS.BdcSalvarClick(Sender: TObject);
begin
If (TxtDescEquip.Text='') or (TxtDescProb.Text='') or (TxtCliente.Text='') or (TxtLocTOS.Text='') Then
  Begin
    Application.MessageBox('Dados Insuficiente para realizar o cadastro!','SC Software',MB_ICONINFORMATION);
    TxtDescEquip.SetFocus;
end
      Else
        Begin
          TbAbrtOS.Post;
          TbAbrtOS.Active:=False;
          TbAbrtOS.Active:=True;
          TbAbrtOS.Last;
          BdcNovo.Enabled:=True;
          BdcSalvar.Enabled:=False;
          BdcImprimir.Enabled:=True;
      end
end;

procedure TFrmAbrtOS.SBClienteClick(Sender: TObject);
begin
Application.CreateForm(TFrmListCli,FrmListCli);
FrmListCli.ShowModal;
end;

procedure TFrmAbrtOS.FormClose(Sender: TObject; var Action: TCloseAction);
begin
TbAbrtOS.Refresh;
TbAbrtOS.Active:=False;
Action:=caFree;
FrmAbrtOS:=Nil;
end;

procedure TFrmAbrtOS.TxtClienteEnter(Sender: TObject);
begin
SBCliente.Click;
end;

procedure TFrmAbrtOS.BdcImprimirClick(Sender: TObject);
begin
QRAbertOS.TbQrepAberOS.Active:=False;
QRAbertOS.TbQrepAberOS.Active:=True;
QRAbertOS.TbQrepAberOS.Filtered:=True;
QRAbertOS.TbQrepAberOS.Filter:='Cod_Ordem='+QuotedStr(TbAbrtOS['Cod_Ordem']);
QRAbertOS.TbCliente.Active:=True;
QRAbertOS.TbCliente.Filtered:=True;
QRAbertOS.TbCliente.Filter:='Nome='+QuotedStr(QRAbertOS.TbQrepAberOSCod_Cliente.AsString);
QRAbertOS.TbItemServico.Active:=True;
QRAbertOS.TbItemServico.Filtered:=True;
QRAbertOS.TbItemServico.Filter:='Cod_Ordem='+QuotedStr(QRAbertOS.TbQrepAberOSCod_Ordem.AsString);
QRAbertOS.Preview;
end;

end.
