unit UntListCliente;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, DB, ADODB, Grids, DBGrids;

type
  TFrmListCli = class(TForm)
    Image1: TImage;
    Label1: TLabel;
    TxtLocCliente: TEdit;
    Label2: TLabel;
    GroupBox1: TGroupBox;
    DBGrid1: TDBGrid;
    DsListCliente: TDataSource;
    TbListCliente: TADOTable;
    TbListClienteCodigo_Cliente: TAutoIncField;
    TbListClienteData_Cad: TDateTimeField;
    TbListClientePF_PJ: TWideStringField;
    TbListClienteNome: TWideStringField;
    TbListClienteData_Nascimento: TDateTimeField;
    TbListClienteCPF: TWideStringField;
    TbListClienteIE: TWideStringField;
    TbListClienteCGC: TWideStringField;
    TbListClienteRazao_Social: TWideStringField;
    TbListClienteRG: TWideStringField;
    TbListClienteFone: TWideStringField;
    TbListClienteFax: TWideStringField;
    TbListClienteE_Mail: TWideStringField;
    TbListClienteSite: TWideStringField;
    TbListClienteEndereco: TWideStringField;
    TbListClienteCidade: TWideStringField;
    TbListClienteCEP: TWideStringField;
    TbListClienteUF: TWideStringField;
    TbListClienteObs: TMemoField;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure TxtLocClienteChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure TxtLocClienteKeyPress(Sender: TObject; var Key: Char);
    procedure DBGrid1DblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmListCli: TFrmListCli;

implementation

uses UntPrincipal, UntSCV, UntCadTS, UntAbertOS;

{$R *.dfm}

procedure TFrmListCli.FormKeyPress(Sender: TObject; var Key: Char);
begin
If Key=#27 Then
  Begin
    FrmListCli.Close;
end
end;

procedure TFrmListCli.TxtLocClienteChange(Sender: TObject);
begin
TbListCliente.Locate('Razao_Social',( TxtLocCliente.Text),[loPartialKey, loCaseInsensitive]);
end;

procedure TFrmListCli.FormClose(Sender: TObject; var Action: TCloseAction);
begin
TbListCliente.Active:=False;
Action:=caFree;
FrmListCli:=Nil;
end;

procedure TFrmListCli.FormShow(Sender: TObject);
begin
TbListCliente.Active:=True;
end;

procedure TFrmListCli.TxtLocClienteKeyPress(Sender: TObject;
  var Key: Char);
begin
If Key=#13 Then
  Begin
    Key:=#0
end
end;

procedure TFrmListCli.DBGrid1DblClick(Sender: TObject);
begin
FrmAbrtOS.TxtCliente.Text:=TbListClienteRazao_Social.AsString;
FrmListCli.Close;
end;

end.
