unit UntPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, MPlayer, ComCtrls, ActnMan, ActnColorMaps, ActnList,
  StdStyleActnCtrls, ToolWin, ActnCtrls, ActnMenus, StdCtrls, Buttons,
  ExtDlgs, Menus, DB, DBTables, DBCtrls, Winsock, Shellapi, MMSystem,
  ImgList, ADODB;

type
  TFrmPrincipal = class(TForm)
    BarradeMenu: TActionMainMenuBar;
    Acoes: TActionManager;
    EncerrarSistema: TAction;
    Logoff: TAction;
    CadCliente: TAction;
    CadUsu: TAction;
    About: TAction;
    Enviar: TAction;
    MenuMSG: TAction;
    Compra: TAction;
    Ajuda: TAction;
    Cores: TXPColorMap;
    Hora: TTimer;
    StatusBar: TStatusBar;
    CadFornecedor: TAction;
    Panel1: TPanel;
    Panel3: TPanel;
    SBCadCliente: TSpeedButton;
    SBCadUsu: TSpeedButton;
    SBCadRotas: TSpeedButton;
    ContasPagar: TAction;
    PopupMenu1: TPopupMenu;
    CarregarImagem1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    CarregarImagem: TOpenPictureDialog;
    DsSis: TDataSource;
    Venda: TAction;
    Entrega: TAction;
    RelForn: TAction;
    Calculadora: TAction;
    RelCli: TAction;
    RelFun: TAction;
    RelUsu: TAction;
    TbPreco: TAction;
    TerminateSis: TTimer;
    Teclado: TAction;
    GVenda: TAction;
    ConsCliente: TAction;
    Timer2: TTimer;
    ImageList1: TImageList;
    ConsProd: TAction;
    DemoCaixa: TAction;
    Image1: TImage;
    TbUsu: TADOTable;
    TbUsuCodigo: TAutoIncField;
    TbUsuNome: TWideStringField;
    TbUsuLogin: TWideStringField;
    TbUsuSenha: TWideStringField;
    TbUsuConfSenha: TWideStringField;
    TbUsuAcesso: TWideStringField;
    TbUsuStatus: TWideStringField;
    Label1: TLabel;
    procedure HoraTimer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure EncerrarSistemaExecute(Sender: TObject);
    procedure LogoffExecute(Sender: TObject);
    procedure CadClienteExecute(Sender: TObject);
    procedure CadUsuExecute(Sender: TObject);
    procedure CadFornecedorExecute(Sender: TObject);
    procedure CompraExecute(Sender: TObject);
    procedure SBCadUsuClick(Sender: TObject);
    procedure SBCadClienteClick(Sender: TObject);
    procedure SBCadRotasClick(Sender: TObject);
    procedure ContasPagarExecute(Sender: TObject);
    procedure CarregarImagem1Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure MenuMSGExecute(Sender: TObject);
    procedure EnviarExecute(Sender: TObject);
    procedure RelFornExecute(Sender: TObject);
    procedure CalculadoraExecute(Sender: TObject);
    procedure RelCliExecute(Sender: TObject);
    procedure RelFunExecute(Sender: TObject);
    procedure RelUsuExecute(Sender: TObject);
    procedure TbPrecoExecute(Sender: TObject);
    procedure BackUpExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TerminateSisTimer(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TecladoExecute(Sender: TObject);
    procedure GVendaExecute(Sender: TObject);
    procedure ConsClienteExecute(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure ConsProdExecute(Sender: TObject);
    procedure AboutExecute(Sender: TObject);
    procedure DemoCaixaExecute(Sender: TObject);
    procedure VendaExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmPrincipal: TFrmPrincipal;
  Forms:String;
  Form:String;
  Con:String;
  Cons:String;

implementation

uses UntCadCliente, UntSCV, UntLogin, UntCadUsu, UntCadTS, UntAbertOS,
  UntQrepAbertOS, UntConclusaoOS, UntQRepPrinCli, UntQRepPrinTS, UntSobre;

{$R *.dfm}

procedure TFrmPrincipal.HoraTimer(Sender: TObject);
begin
StatusBar.Panels[5].Text:=TimeToStr(Now);
StatusBar.Panels[7].Text:=FormatDateTime('dddddd',Date);
end;

procedure TFrmPrincipal.FormActivate(Sender: TObject);
begin
Hora.Enabled:=True;
end;

procedure TFrmPrincipal.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
Hora.Enabled:=False;
end;

procedure TFrmPrincipal.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
CanClose := false;
If Application.MessageBox('A T E N   O ! ! !'#13'Realmente deseja encerrar o sistema ? ? ?','SC Software',MB_ICONQUESTION+MB_YESNO)=mrYes Then
  Begin
    TbUsu.Active:=True;
    TbUsu.Locate('Login',StatusBar.Panels[1].Text,[]);
    TbUsu.Edit;
    TbUsu.FieldValues['Status']:='OFFLINE';
    TbUsu.Post;
    TbUsu.Active:=False;
    Application.Terminate;
end
    Else
      Abort;
end;

procedure TFrmPrincipal.EncerrarSistemaExecute(Sender: TObject);
begin
If Application.MessageBox('A T E N   O ! ! !'#13'Realmente deseja encerrar o sistema ? ? ?','SC Software',MB_ICONQUESTION+MB_YESNO)=mrYes Then
  Begin
    TbUsu.Active:=True;
    TbUsu.Locate('Login',StatusBar.Panels[1].Text,[]);
    TbUsu.Edit;
    TbUsu.FieldValues['Status']:='OFFLINE';
    TbUsu.Post;
    TbUsu.Active:=False;
    Application.Terminate;
end
    Else
      Abort;
end;

procedure TFrmPrincipal.LogoffExecute(Sender: TObject);
begin
FrmPrincipal.Hide;
Application.CreateForm(TFrmLogin,FrmLogin);
TbUsu.Active:=True;
TbUsu.Locate('Login',StatusBar.Panels[1].Text,[]);
TbUsu.Edit;
TbUsu.FieldValues['Status']:='OFFLINE';
TbUsu.Post;
TbUsu.Active:=False;
FrmLogin.Show;
end;

procedure TFrmPrincipal.CadClienteExecute(Sender: TObject);
begin
Application.CreateForm(TFrmCadCliente,FrmCadCliente);
FrmCadCliente.ShowModal;
end;

procedure TFrmPrincipal.CadUsuExecute(Sender: TObject);
begin
Application.CreateForm(TFrmUsuario,FrmUsuario);
If StatusBar.Panels[3].Text<>'AVANADO' Then
  Begin
    Application.MessageBox('Voc no tem permisso para acessar este formulrio!!!','SC Software',MB_ICONINFORMATION);
end
      Else
        Begin
          FrmUsuario.ShowModal;
       end
end;

procedure TFrmPrincipal.CadFornecedorExecute(Sender: TObject);
begin
Application.CreateForm(TFrmCadTS,FrmCadTS);
FrmCadTS.ShowModal;
end;

procedure TFrmPrincipal.CompraExecute(Sender: TObject);
begin
Application.CreateForm(TFrmAbrtOS,FrmAbrtOS);
FrmAbrtOS.ShowModal;
end;

procedure TFrmPrincipal.SBCadUsuClick(Sender: TObject);
begin
CadUsu.Execute;
end;

procedure TFrmPrincipal.SBCadClienteClick(Sender: TObject);
begin
CadCliente.Execute;
end;

procedure TFrmPrincipal.SBCadRotasClick(Sender: TObject);
begin
CadFornecedor.Execute;
end;

procedure TFrmPrincipal.ContasPagarExecute(Sender: TObject);
begin
{Application.CreateForm(TFrmAgenPag,FrmAgenPag);
If StatusBar.Panels[5].Text='BSICO' Then
  Begin
    Application.MessageBox('Voc no tem permisso para acessar este formulrio!!!','SC Software',MB_ICONINFORMATION);
end
      Else
        Begin
          Form:='( Conta  Pagar) - ';
          Forms:=Forms + Form;
          FrmAgenPag.ShowModal;
       end  }
end;

procedure TFrmPrincipal.CarregarImagem1Click(Sender: TObject);
begin
{CarregarImagem.Execute;
TbSis.Prior;
TbSis.Edit;
If Application.MessageBox('Realmente deseja inserir esta imagem'#13'como plano de fundo da rea de trabalho???','SC Software',MB_ICONQUESTION+MB_YESNO)=mrYes Then
  Begin
    DbSis.Picture.LoadFromFile(CarregarImagem.FileName);
    TbSis.Post;
end
      Else
        Abort;
        TbSis.Cancel;  }
end;

procedure TFrmPrincipal.N1Click(Sender: TObject);
begin
{TbSis.Prior;
TbSis.Edit;
If TbSis.FieldValues['Area']='' Then
  Begin
    Application.MessageBox('O sistema no encontrou nenhuma imagem na rea de trabalho','SC Software',MB_ICONINFORMATION);
end
      Else
        TbSisArea.Assign(Nil);
        TbSis.Post; }
end;

procedure TFrmPrincipal.MenuMSGExecute(Sender: TObject);
begin
//QRepPrinProd.Preview;
end;

procedure TFrmPrincipal.EnviarExecute(Sender: TObject);
begin
Application.MessageBox('Formulrio no liberado para este sistema!!!'#13'Se desejar incluir Contas a Receber neste sistema,'#13'favor entrar em contato com SC Software.','SC Software',MB_ICONINFORMATION);
end;

procedure TFrmPrincipal.RelFornExecute(Sender: TObject);
begin
QRepPrinTS.Preview;
end;

procedure TFrmPrincipal.CalculadoraExecute(Sender: TObject);
begin
Winexec('calc.exe',sw_show);
end;

procedure TFrmPrincipal.RelCliExecute(Sender: TObject);
begin
QRepPrinCli.Preview;
end;

procedure TFrmPrincipal.RelFunExecute(Sender: TObject);
begin
//QRepPrinFun.Preview;
end;

procedure TFrmPrincipal.RelUsuExecute(Sender: TObject);
begin
//QRepPrinUsu.Preview;
end;

procedure TFrmPrincipal.TbPrecoExecute(Sender: TObject);
begin
//QRepPrinTP.Preview;
end;

procedure TFrmPrincipal.BackUpExecute(Sender: TObject);
begin
{Application.CreateForm(TFrmBackup,FrmBackup);
If StatusBar.Panels[5].Text<>'AVANADO' Then
  Begin
    Application.MessageBox('Voc no tem permisso para acessar este formulrio!!!','SC Software',MB_ICONINFORMATION);
end
      Else
        If Application.MessageBox('A T E N   O ! ! !'#13#13'Para que seu backup seja realizado com segurana, o sistema ser encerrado.'#13'Aps a concluso, o sistema de backup reabrir o aplicativo'#13#13' D E S E J A   P R O S S E G U I R ? ? ?','SC Software',MB_ICONQUESTION+MB_YESNO)=mrYes Then
          Begin
            DataModulos.TbUsu.Active:=True;
            DataModulos.TbUsu.Locate('Login',StatusBar.Panels[1].Text,[]);
            DataModulos.TbUsu.Edit;
            DataModulos.TbUsu.FieldValues['Status']:='OFFLINE';
            DataModulos.TbUsu.Post;
            DataModulos.TbUsu.Active:=False;
            FrmPrincipal.Hide;
            TLogoff.Enabled:=True;
            FrmBackup.ShowModal;
      end    }
end;

procedure TFrmPrincipal.FormShow(Sender: TObject);
var
  p : PHostEnt;
  s : array[0..128] of char;
  p2 : pchar;
  HName:String;
  IP:String;
begin
{Timer2.Enabled:=True;
GetHostName(@s, 128);
p := GetHostByName(@s);
DataModulos.TbSistema.Active:=True;
DataModulos.TbSistema.Append;
HName:=p^.h_name;
DataModulos.TbSistema.FieldValues['Computador']:=HName;
p2 := iNet_ntoa(PInAddr(p^.h_addr_list^)^);
IP:=p2;
DataModulos.TbSistema.FieldValues['IP']:=ip;
DataModulos.TbSistema.FieldValues['HEntrada']:=TimeToStr(Time);
DataModulos.TbSistema.FieldValues['Data']:=DateToStr(Now);
Timer1.Enabled:=True;   }
end;

procedure TFrmPrincipal.TerminateSisTimer(Sender: TObject);
Var
  HE:Real;
  HS:Real;
  Total:Real;
begin
{DataModulos.TbSistema.Active:=True;
DataModulos.TbSistema.Last;
DataModulos.TbSistema.Edit;
DataModulos.TbSistema.FieldValues['HSaida']:=StatusBar.Panels[7].Text;
HE:=DataModulos.TbSistema.FieldValues['HEntrada'];
HS:=DataModulos.TbSistema.FieldValues['HSaida'];
Total:=HS-HE;
DataModulos.TbSistema.FieldValues['TempoEstimado']:=Total;
DataModulos.TbSistema.FieldValues['FormsMex']:=Forms;
DataModulos.TbSistema.FieldValues['ConsEfet']:=Cons;
DataModulos.TbSistema.Post;
DataModulos.TbSistema.Active:=False;
Application.Terminate;   }
end;

procedure TFrmPrincipal.FormDestroy(Sender: TObject);
begin
WSACleanup;
end;

procedure TFrmPrincipal.FormCreate(Sender: TObject);
Var
    wVersionRequested : WORD;
    wsaData : TWSAData;
begin
wVersionRequested := MAKEWORD(1, 1);
WSAStartup(wVersionRequested, wsaData);
end;

procedure TFrmPrincipal.TecladoExecute(Sender: TObject);
begin
Winexec('osk.exe',sw_show);
end;

procedure TFrmPrincipal.GVendaExecute(Sender: TObject);
begin
{Application.CreateForm(TFrmGraficoVenda,FrmGraficoVenda);
FrmGraficoVenda.ShowModal;}
end;

procedure TFrmPrincipal.ConsClienteExecute(Sender: TObject);
begin
{Application.CreateForm(TFrmConsCliente,FrmConsCliente);
Con:='( Cliente) - ';
Cons:=Cons + Con;
FrmConsCliente.ShowModal;  }
end;

procedure TFrmPrincipal.Timer2Timer(Sender: TObject);
Var
  Hora: Real;
begin
   Hora:=Time;
If Hora <=0.5000 then
  Begin
  SndPlaySound('C:\SOS\Others\bom_dia.wav', snd_ASync);
  Timer2.Enabled:=False;
end
    else
  if (Hora >0.5000) and (Hora<=0.7504) then
  begin
  SndPlaySound('C:\SOS\Others\boa_tarde.wav', snd_ASync);
  Timer2.Enabled:=False;
  end
    else
    begin
  SndPlaySound('C:\SOS\Others\boa_noite.wav', snd_ASync);
  Timer2.Enabled:=False;
end
end;

procedure TFrmPrincipal.ConsProdExecute(Sender: TObject);
begin
{Application.CreateForm(TFrmConsProd,FrmConsProd);
Con:='( Produtos) - ';
Cons:=Cons + Con;
FrmConsProd.ShowModal; }
end;

procedure TFrmPrincipal.AboutExecute(Sender: TObject);
begin
Application.CreateForm(TFrmAbout,FrmAbout);
FrmAbout.ShowModal;
end;

procedure TFrmPrincipal.DemoCaixaExecute(Sender: TObject);
begin
{Application.CreateForm(TFrmCaixa,FrmCaixa);
FrmCaixa.ShowModal;   }
end;

procedure TFrmPrincipal.VendaExecute(Sender: TObject);
begin
Application.CreateForm(TFrmConclusaoOS,FrmConclusaoOS);
FrmConclusaoOS.ShowModal;
end;

end.
